﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using Infragistics.Controls.Charts;

namespace WpfApplication1.Views.Gauges
{
    public class ScaleBinder
            : DependencyObject
    {
        private static Type[] GaugeTypes = new[]
                                               {
                                                   typeof (XamLinearGauge), typeof (XamRadialGauge) //, typeof (XamSegmentedDisplay)
                                               };

        public static DependencyProperty ContextBridgeProperty =
            DependencyProperty.RegisterAttached("ContextBridge",
                                                typeof(object), typeof(ScaleBinder),
                                                new PropertyMetadata(null,
                                                                     (o, e) =>
                                                                     {
                                                                         ScaleBindingInfo sbi = GetBindingInfo(o);
                                                                         if (sbi != null)
                                                                         {
                                                                             sbi.OuterContext = e.NewValue;
                                                                         }
                                                                     }));

        public static DependencyProperty BindingInfoProperty =
            DependencyProperty.RegisterAttached("BindingInfo",
                                                typeof(ScaleBindingInfo), typeof(ScaleBinder),
                                                new PropertyMetadata(null,
                                                                     (o, e) =>
                                                                     {
                                                                         if ( GaugeTypes.Contains( o.GetType() ))
                                                                         {
                                                                             ScaleBindingInfo prev =
                                                                                 GetBindingInfo(o);
                                                                             if (prev != null && prev.Owner != null)
                                                                             {
                                                                                 prev.Owner = null;
                                                                             }
                                                                             if (e.NewValue != null)
                                                                             {
                                                                                 var newOwner =
                                                                                     o as Control;
                                                                                 newOwner.SetBinding(
                                                                                     ScaleBinder.
                                                                                         ContextBridgeProperty,
                                                                                     new Binding());

                                                                                 (e.NewValue as ScaleBindingInfo)
                                                                                     .Owner = newOwner;

                                                                                 if (GetContextBridge(o) != null)
                                                                                 {
                                                                                     (e.NewValue as
                                                                                      ScaleBindingInfo)
                                                                                         .OuterContext =
                                                                                         GetContextBridge(o);
                                                                                 }
                                                                             }
                                                                         }
                                                                     }));


        public static void SetBindingInfo(
            DependencyObject target,
            ScaleBindingInfo info)
        {
            target.SetValue(BindingInfoProperty, info);
        }

        public static ScaleBindingInfo GetBindingInfo(
            DependencyObject target)
        {
            return (ScaleBindingInfo)target.GetValue(BindingInfoProperty);
        }

        public static void SetContextBridge(
            DependencyObject target,
            object context)
        {
            target.SetValue(ContextBridgeProperty, context);
        }

        public static object GetContextBridge(
            DependencyObject target)
        {
            return target.GetValue(ContextBridgeProperty);
        }
    }

}
